﻿package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import funnel.*;
	import funnel.i2c.*;

	/**
	* ...
	* @author Kazushi Mukaiyama
	*/
	public class Main extends Sprite {
		private var fio:Fio;
		private var accl:LIS302DL;
		
		private var cx:Number;
		private var cy:Number;
		private var cz:Number;
		private var px:Number = 0;
		private var py:Number = 0;
		private var pz:Number = 0;
		
		
		
		public function Main() {
			trace("start");
			init();
			addEvents();
		}
		
		private function init():void
		{
			var config:Configuration = Fio.FIRMATA;
			config.setDigitalPinMode(12, IN);
			config.setDigitalPinMode(13, OUT);
			
			// set unused analog pins to digital outputs to save processor time
			config.setDigitalPinMode(15, OUT);	// set A1 as digital output
			config.setDigitalPinMode(16, OUT);	// set A2 as digital output
			config.setDigitalPinMode(17, OUT);	// set A3 as digital output		
			config.setDigitalPinMode(20, OUT);	// set A6 as digital output		
			config.setDigitalPinMode(21, OUT);	// set A7 as digital output		

			fio = new Fio([1], config);
			accl = new LIS302DL(fio.ioModule(1));
			
			anim.gotoAndStop(1);
		}
		
		private function addEvents():void
		{
			fio.addEventListener(FunnelEvent.READY, trace);
			fio.addEventListener(FunnelErrorEvent.REBOOT_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.CONFIGURATION_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.ERROR, trace);
			
			// ループ
			this.addEventListener(Event.ENTER_FRAME, enterFrame);
		}
		
		private var hurikake:uint = 0;
		private var have:Boolean = false;
		private var scene:uint = 0;
		
		private function enterFrame(e:Event):void 
		{
			cx = accl.x;
			cy = accl.y;
			cz = accl.z;			
			
			if (scene < 24) scene++;			
			if (scene == 24 && !have && cx != 0 && (cx > 0.2 || cx < -0.2)) {
				have = true;
				anim.gotoAndStop(2);
			}
			
			if (have) {
				if (Math.abs(pz - cz) > 1.0) {
					hurikake += 1;

					switch(hurikake) {
						case 3:
							anim.gotoAndStop(3);
							break;
						case 6:
							anim.gotoAndStop(4);
							break;
						case 9:
							anim.gotoAndStop(5);
							break;
						case 12:
							anim.gotoAndStop(6);
							break;
						case 15:
							anim.gotoAndStop(7);
							break;
						default:
							break;
					}
				}else if (hurikake>14 && Math.abs(py - cy) > 1.2) {
					anim.gotoAndStop(1);
					hurikake = 0;
					have = false;
					scene = 0;
				}
			}
					
			px = cx;
			py = cy;
			pz = cz;
		}
	}
}